
-- Vario Grip - extended
-- Date 30.10.2016/ 10.4.2018
-- Copyright (C) Slavo LS Modding
-- Edit by Jukka


variogrip = {};

exvariogrip = false;

function variogrip.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function variogrip:load(xmlFile)
	self.m = 1;
	self.variogrip = true;
	self.hasVarioGrip = true;

	self.suspFront = self.wheels[1].suspTravel;
	self.suspBack = self.wheels[3].suspTravel;

	self.deformFront = self.wheels[1].maxDeformation;
	self.deformBack = self.wheels[3].maxDeformation;

	self.frictionFront = self.wheels[1].frictionScale;
	self.frictionBack = self.wheels[3].frictionScale;
end;

function variogrip:delete()
end;

function variogrip:readStream(streamId, connection)
end;

function variogrip:writeStream(streamId, connection)
end;

function variogrip:mouseEvent(posX, posY, isDown, isUp, button)
end;

function variogrip:keyEvent(unicode, sym, modifier, isDown)
end;

function variogrip:update(dt)
	
	if self.isMotorStarted then
		if InputBinding.hasEvent(InputBinding.VarioGrip) or (exvariogrip) then
			if (self.hasVarioGrip) then
				self.variogrip = not self.variogrip;
				exvariogrip = false;
				--setVisibility(Utils.indexToObject(self.components, "0>4|1|3|3"), self.variogrip);
				self.uvg = true;
				if (self.variogrip) then t = 4; else t = 1; end;
			end;
		end;

		if(self.uvg == true) then
		    for i, wheel in ipairs(self.wheels) do
		    	if(self.variogrip) then
		    		if(self.deformFront*t > wheel.maxDeformation) then
		    			self.m = self.m+0.001;

			    		if((i == 1) or (i == 2)) then
			    			wheel.maxDeformation = self.deformFront*self.m;
			    			wheel.frictionScale = self.frictionFront*self.m;
			    		else 
			    			wheel.maxDeformation = self.deformBack*self.m;
			    			wheel.frictionScale = self.frictionBack*self.m;
			    		end;
			    		wheel.suspTravel = wheel.suspTravel - (self.m / 14000);
			    		self:updateWheelTireFriction(wheel);
			    		self:updateWheelBase(wheel);
			    	else
			    		self.uvg = false;
		    		end;
		    	else
		    		if(self.deformFront*t < wheel.maxDeformation) then
		    			self.m = self.m-0.001;

			    		if((i == 1) or (i == 2)) then
			    			wheel.maxDeformation = self.deformFront*self.m;
			    			wheel.frictionScale = self.frictionFront*self.m;
			    		else 
			    			wheel.maxDeformation = self.deformBack*self.m;
			    			wheel.frictionScale = self.frictionBack*self.m;
			    		end;
			    		wheel.suspTravel = wheel.suspTravel + (self.m / 14000);
			    		self:updateWheelTireFriction(wheel);
			    		self:updateWheelBase(wheel);
		    		else 
						self.uvg = false;
		    		end;
		    	end;
			end;

		end;
	end;

end;

function variogrip:updateTick(dt)

end;

function variogrip:draw()
end;

function variogrip:onLeave()
end;

function variogrip:onEnter()
end;